wayland::zxdg_shell_v6_t(3)

NAME
wayland::zxdg_shell_v6_t - create desktop-style surfaces

SYNOPSIS

#include <wayland-client-protocol-unstable.hpp>

Inherits wayland::proxy_t.

  Public Types

enum class wrapper_type { standard, display, foreign, proxy_wrapper }

  Public Member Functions

zxdg_positioner_v6_t create_positioner ()
create a positioner object
zxdg_surface_v6_t get_xdg_surface (surface_t const &surface)
create a shell surface from a surface
void pong (uint32_t serial)
respond to a ping event
std::function< void(uint32_t)> & on_ping ()
check if the client is alive
uint32_t get_id () const
Get the id of a proxy object.
std::string get_class () const
Get the interface name (class) of a proxy object.
uint32_t get_version () const
Get the protocol object version of a proxy object.
wrapper_type get_wrapper_type () const
Get the type of a proxy object.
void set_queue (event_queue_t queue)
Assign a proxy to an event queue.
wl_proxy * c_ptr () const
Get a pointer to the underlying C struct.
bool proxy_has_object () const
Check whether this wrapper actually wraps an object.
operator bool () const
Check whether this wrapper actually wraps an object.
bool operator== (const proxy_t &right) const
Check whether two wrappers refer to the same object.
bool operator!= (const proxy_t &right) const
Check whether two wrappers refer to different objects.
void proxy_release ()
Release the wrapped object (if any), making this an empty wrapper.

  Static Public Attributes

static constexpr std::uint32_t create_positioner_since_version = 1
Minimum protocol version required for the create_positioner function.
static constexpr std::uint32_t get_xdg_surface_since_version = 1
Minimum protocol version required for the get_xdg_surface function.
static constexpr std::uint32_t pong_since_version = 1
Minimum protocol version required for the pong function.

Detailed Description

create desktop-style surfaces

xdg_shell allows clients to turn a wl_surface into a 'real window' which can be dragged, resized, stacked, and moved around by the user. Everything about this interface is suited towards traditional desktop environments.

Definition at line 7686 of file wayland-client-protocol-unstable.hpp.

Member Enumeration Documentation

  enum class wayland::proxy_t::wrapper_type [strong], [inherited]
Underlying wl_proxy type and properties of a proxy_t that affect construction, destruction, and event handling

Enumerator

standard
    C pointer is a standard type compatible with wl_proxy*. Events are dispatched and it is destructed when the proxy_t is destructed. User data is set.

display
    C pointer is a wl_display*. No events are dispatched, wl_display_disconnect is called when the proxy_t is destructed. User data is set.

foreign
    C pointer is a standard type compatible with wl_proxy*, but another library owns it and it should not be touched in a way that could affect the operation of the other library. No events are dispatched, wl_proxy_destroy is not called when the proxy_t is destructed, user data is not touched. Consequently, there is no reference counting for the proxy_t. Lifetime of such wrappers should preferably be short to minimize the chance that the owning library decides to destroy the wl_proxy.

proxy_wrapper
    C pointer is a wl_proxy* that was constructed with wl_proxy_create_wrapper. No events are dispatched, wl_proxy_wrapper_destroy is called when the proxy_t is destroyed. Reference counting is active. A reference to the proxy_t creating this proxy wrapper is held to extend its lifetime until after the proxy wrapper is destroyed.

Definition at line 116 of file wayland-client.hpp.

Member Function Documentation

  wl_proxy * wayland::proxy_t::c_ptr () const [inherited]

Get a pointer to the underlying C struct.

Returns
    The underlying wl_proxy wrapped by this proxy_t if it exists, otherwise an exception is thrown

  zxdg_positioner_v6_t zxdg_shell_v6_t::create_positioner ()

create a positioner object Create a positioner object. A positioner object is used to position surfaces relative to some parent surface. See the interface description and xdg_surface.get_popup for details.

Definition at line 9679 of file wayland-client-protocol-unstable.cpp.

  std::string wayland::proxy_t::get_class () const [inherited]

Get the interface name (class) of a proxy object.

Returns
    The interface name of the object associated with the proxy

  uint32_t wayland::proxy_t::get_id () const [inherited]

Get the id of a proxy object.

Returns
    The id the object associated with the proxy

  uint32_t wayland::proxy_t::get_version () const [inherited]

Get the protocol object version of a proxy object. Gets the protocol object version of a proxy object, or 0 if the proxy was created with unversioned API.

A returned value of 0 means that no version information is available, so the caller must make safe assumptions about the object's real version.

display_t will always return version 0.

Returns
    The protocol object version of the proxy or 0

  wrapper_type wayland::proxy_t::get_wrapper_type () const [inline], [inherited]

Get the type of a proxy object.

Definition at line 302 of file wayland-client.hpp.

  zxdg_surface_v6_t zxdg_shell_v6_t::get_xdg_surface (surface_t const & surface)

create a shell surface from a surface

Parameters
    surface

This creates an xdg_surface for the given surface. While xdg_surface itself is not a role, the corresponding surface may only be assigned a role extending xdg_surface, such as xdg_toplevel or xdg_popup.

This creates an xdg_surface for the given surface. An xdg_surface is used as basis to define a role to a given surface, such as xdg_toplevel or xdg_popup. It also manages functionality shared between xdg_surface based surface roles.

See the documentation of xdg_surface for more details about what an xdg_surface is and how it is used.

Definition at line 9686 of file wayland-client-protocol-unstable.cpp.

  std::function< void(uint32_t)> & zxdg_shell_v6_t::on_ping ()

check if the client is alive

Parameters
    serial pass this to the pong request

The ping event asks the client if it's still alive. Pass the serial specified in the event back to the compositor by sending a 'pong' request back with the specified serial. See xdg_shell.ping.

Compositors can use this to determine if the client is still alive. It's unspecified what will happen if the client doesn't respond to the ping request, or in what timeframe. Clients should try to respond in a reasonable amount of time.

A compositor is free to ping in any way it wants, but a client must always respond to any xdg_shell object it created.

Definition at line 9699 of file wayland-client-protocol-unstable.cpp.

  wayland::proxy_t::operator bool () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

  bool wayland::proxy_t::operator!= (const proxy_t & right) const [inherited]

Check whether two wrappers refer to different objects.

  bool wayland::proxy_t::operator== (const proxy_t & right) const [inherited]

Check whether two wrappers refer to the same object.

  void zxdg_shell_v6_t::pong (uint32_t serial)

respond to a ping event

Parameters
    serial serial of the ping event

A client must respond to a ping event with a pong request or the client may be deemed unresponsive. See xdg_shell.ping.

Definition at line 9693 of file wayland-client-protocol-unstable.cpp.

  bool wayland::proxy_t::proxy_has_object () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

  void wayland::proxy_t::proxy_release () [inherited]

Release the wrapped object (if any), making this an empty wrapper. Note that display_t instances cannot be released this way. Attempts to do so are ignored.

Examples
foreign_display.cpp.

  void wayland::proxy_t::set_queue (event_queue_t queue) [inherited]

Assign a proxy to an event queue.

Parameters
    queue The event queue that will handle this proxy

Assign proxy to event queue. Events coming from proxy will be queued in queue instead of the display's main queue.

See also: display_t::dispatch_queue().

Examples
proxy_wrapper.cpp.

Member Data Documentation

  constexpr std::uint32_t wayland::zxdg_shell_v6_t::create_positioner_since_version = 1 [static], [constexpr]

Minimum protocol version required for the create_positioner function.

Definition at line 7720 of file wayland-client-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::zxdg_shell_v6_t::get_xdg_surface_since_version = 1 [static], [constexpr]

Minimum protocol version required for the get_xdg_surface function.

Definition at line 7742 of file wayland-client-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::zxdg_shell_v6_t::pong_since_version = 1 [static], [constexpr]

Minimum protocol version required for the pong function.

Definition at line 7755 of file wayland-client-protocol-unstable.hpp.

Author

Generated automatically by Doxygen for Wayland++ from the source code.